var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
function simulateTyping(element_1, text_1) {
    return __awaiter(this, arguments, void 0, function (element, text, delay) {
        var act, _text;
        if (delay === void 0) { delay = 100; }
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, import('@testing-library/react')];
                case 1:
                    act = (_a.sent()).act;
                    _text = text;
                    if (text.length === 0) {
                        _text = '0';
                    }
                    return [2 /*return*/, new Promise(function (resolve) {
                            var index = 0;
                            function typeCharacter() {
                                if (index < _text.length) {
                                    var char = _text[index];
                                    var eventOptions_1 = {
                                        key: char,
                                        keyCode: char.charCodeAt(0),
                                        which: char.charCodeAt(0),
                                        bubbles: true,
                                    };
                                    act(function () {
                                        element.dispatchEvent(new KeyboardEvent('keydown', eventOptions_1));
                                    });
                                    index++;
                                    setTimeout(typeCharacter, delay);
                                }
                                else {
                                    resolve(); // Resolve the promise when done
                                }
                            }
                            typeCharacter();
                        })];
            }
        });
    });
}
function leftPad(str, len, ch) {
    if (len === void 0) { len = 2; }
    if (ch === void 0) { ch = '0'; }
    var newStr = str;
    while (newStr.length < len) {
        newStr = ch + newStr;
    }
    return newStr;
}
/**
 * Get a datepicker with helper functions by label
 *
 * @param label label of the datepicker element you want to get
 * @param index if there are multiple datepicker elements with the same label, you can specify which one you want to get
 * @returns DatepickerTestHelper
 */
export function getDatepickerByLabelText(label_1) {
    return __awaiter(this, arguments, void 0, function (label, index) {
        function getValue(element) {
            var _a = Array.from(element.querySelectorAll('[role="spinbutton"]')), dayElement = _a[0], monthElement = _a[1], yearElement = _a[2];
            var day = dayElement.getAttribute('aria-valuenow') || '';
            var month = monthElement.getAttribute('aria-valuenow') || '';
            var year = yearElement.getAttribute('aria-valuenow') || '';
            return year !== '' &&
                year !== '0' &&
                month !== '' &&
                month !== '0' &&
                day !== '' &&
                day !== '0'
                ? "".concat(leftPad(day), ".").concat(leftPad(month), ".").concat(year)
                : '';
        }
        function setValue(element, value) {
            return __awaiter(this, void 0, void 0, function () {
                var act, _a, dayElement, monthElement, yearElement, _b, dayValue, monthValue, yearValue;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0: return [4 /*yield*/, import('@testing-library/react')];
                        case 1:
                            act = (_c.sent()).act;
                            _a = Array.from(element.querySelectorAll('[role="spinbutton"]')), dayElement = _a[0], monthElement = _a[1], yearElement = _a[2];
                            _b = value
                                ? value.split('.')
                                : ['0', '0', '0'], dayValue = _b[0], monthValue = _b[1], yearValue = _b[2];
                            dayValue = dayValue.length === 1 ? "0".concat(dayValue) : dayValue;
                            monthValue = monthValue.length === 1 ? "0".concat(monthValue) : monthValue;
                            return [4 /*yield*/, simulateTyping(dayElement, dayValue)];
                        case 2:
                            _c.sent();
                            return [4 /*yield*/, simulateTyping(monthElement, monthValue)];
                        case 3:
                            _c.sent();
                            return [4 /*yield*/, simulateTyping(yearElement, yearValue)];
                        case 4:
                            _c.sent();
                            act(function () { return yearElement.blur(); });
                            return [2 /*return*/];
                    }
                });
            });
        }
        var screen, elements;
        if (index === void 0) { index = 0; }
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, import('@testing-library/react')];
                case 1:
                    screen = (_a.sent()).screen;
                    elements = screen
                        .getAllByText(label)
                        .map(function (element) {
                        var _a, _b;
                        return (_b = (_a = element.parentElement) === null || _a === void 0 ? void 0 : _a.parentElement) === null || _b === void 0 ? void 0 : _b.querySelector('.ffe-datepicker');
                    })
                        .filter(function (element) { return element !== null && element !== undefined; });
                    return [2 /*return*/, {
                            element: elements[index],
                            getValue: function () { return getValue(elements[index]); },
                            setValue: function (value) { return setValue(elements[index], value); },
                        }];
            }
        });
    });
}
