"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DatepickerComp = void 0;
var react_1 = __importStar(require("react"));
var DatepickerContext_1 = require("./DatepickerContext");
var SpinButton_1 = require("./SpinButton");
var padZero_1 = require("./padZero");
var button_1 = require("../button");
var calendar_1 = require("../calendar");
var dateUtil_1 = require("../util/dateUtil");
var lodash_debounce_1 = __importDefault(require("lodash.debounce"));
var classnames_1 = __importDefault(require("classnames"));
var simpledate_1 = require("../datelogic/simpledate");
var ffe_form_react_1 = require("@sb1/ffe-form-react");
var i18n_1 = __importDefault(require("../i18n/i18n"));
var types_1 = require("../types");
var DatepickerComp = function (_a) {
    var ariaInvalidState = _a.ariaInvalid, ariaInvalidProp = _a["aria-invalid"], ariaDescribedbyState = _a.ariaDescribedby, ariaDescribedbyProp = _a["aria-describedby"], onBlur = _a.onBlur, calendarAbove = _a.calendarAbove, id = _a.id, maxDateProp = _a.maxDate, minDateProp = _a.minDate, onChange = _a.onChange, fullWidth = _a.fullWidth, fieldMessage = _a.fieldMessage, labelId = _a.labelId, dropdownCaption = _a.dropdownCaption;
    var _b = (0, react_1.useContext)(DatepickerContext_1.DatepickerContext), day = _b.day, setDay = _b.setDay, year = _b.year, setYear = _b.setYear, month = _b.month, setMonth = _b.setMonth, locale = _b.locale, calendarActiveDate = _b.calendarActiveDate, setCalendarActiveDate = _b.setCalendarActiveDate, setLastChangedValue = _b.setLastChangedValue;
    var formatDate = (0, react_1.useCallback)(function () {
        return (0, dateUtil_1.getPaddedDateString)(day, month, year);
    }, [day, month, year]);
    var _c = (0, react_1.useState)(false), displayDatePicker = _c[0], setDisplayDatePicker = _c[1];
    var _d = (0, react_1.useState)(minDateProp), minDate = _d[0], setMinDate = _d[1];
    var _e = (0, react_1.useState)(maxDateProp), maxDate = _e[0], setMaxDate = _e[1];
    var _f = (0, react_1.useState)(formatDate()), lastValidDate = _f[0], setLastValidDate = _f[1];
    var datepickerId = (0, react_1.useId)();
    var buttonRef = (0, react_1.useRef)(null);
    var dayRef = (0, react_1.useRef)(null);
    var monthRef = (0, react_1.useRef)(null);
    var yearRef = (0, react_1.useRef)(null);
    var getFieldMessageId = function () {
        return fieldMessage ? "".concat(datepickerId, "-fieldmessage") : undefined;
    };
    var _onChange = (0, react_1.useCallback)(function (date) {
        setLastChangedValue(date);
        onChange(date);
    }, [onChange, setLastChangedValue]);
    var fieldMessageId = getFieldMessageId();
    // eslint-disable-next-line react-hooks/exhaustive-deps
    var debounceCalendar = (0, react_1.useCallback)((0, lodash_debounce_1.default)(function (newValue) {
        if (newValue !== lastValidDate && (0, dateUtil_1.validateDate)(newValue)) {
            setCalendarActiveDate(newValue);
            setLastValidDate(newValue);
        }
    }, 250), [lastValidDate]);
    var hasMessage = !!fieldMessage;
    (0, react_1.useEffect)(function () {
        return function () {
            debounceCalendar.cancel();
        };
    }, [debounceCalendar]);
    var validateDateIntervals = (0, react_1.useCallback)(function () {
        var dateString = formatDate();
        (0, simpledate_1.getSimpleDateFromString)(dateString, function (date) {
            var maxDateValidated = maxDateProp
                ? (0, simpledate_1.getSimpleDateFromString)(maxDateProp)
                : null;
            if ((maxDateValidated === null || maxDateValidated === void 0 ? void 0 : maxDateValidated.isBefore(date)) &&
                (0, dateUtil_1.isDateInputWithTwoDigitYear)(dateString)) {
                date.adjust({ period: 'Y', offset: -100 });
            }
            var formattedDate = date.format();
            if (formattedDate !== dateString) {
                setDay([date.date]);
                setMonth([date.month + 1]);
                setYear([date.year]);
            }
            setLastValidDate(formattedDate);
        });
    }, [formatDate, maxDateProp, setDay, setMonth, setYear]);
    (0, react_1.useEffect)(function () {
        if (minDateProp !== minDate || maxDateProp !== maxDate) {
            setMinDate(minDateProp);
            setMaxDate(maxDateProp);
            validateDateIntervals();
        }
        debounceCalendar(formatDate());
    }, [
        minDateProp,
        maxDateProp,
        formatDate,
        debounceCalendar,
        minDate,
        maxDate,
        validateDateIntervals,
    ]);
    var closeCalendarSetInputFocus = function () {
        var _a;
        setDisplayDatePicker(false);
        (_a = buttonRef.current) === null || _a === void 0 ? void 0 : _a.focus();
        validateDateIntervals();
    };
    var escKeyHandler = function (evt) {
        if (evt.key === 'Escape') {
            closeCalendarSetInputFocus();
        }
    };
    var globalClickHandler = function (evt) {
        if (displayDatePicker && evt.__datepickerID !== datepickerId) {
            closeCalendarSetInputFocus();
        }
    };
    var addGlobalEventListeners = function () {
        window.addEventListener('click', globalClickHandler);
        window.addEventListener('keyup', escKeyHandler);
    };
    var removeGlobalEventListeners = function () {
        window.removeEventListener('click', globalClickHandler);
        window.removeEventListener('keyup', escKeyHandler);
    };
    (0, react_1.useEffect)(function () {
        if (displayDatePicker) {
            addGlobalEventListeners();
        }
        else {
            removeGlobalEventListeners();
        }
        return function () {
            removeGlobalEventListeners();
        };
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [displayDatePicker]);
    var calendarButtonClickHandler = function () {
        validateDateIntervals();
        setDisplayDatePicker(!displayDatePicker);
    };
    /**
     * Adds a flag on the click event so that the globalClickHandler()
     * can determine whether the ID matches. Makes it so that only one datepicker can be open at the same time
     */
    var addFlagOnClickEventClickHandler = function (evt) {
        var nativeEvent = evt.nativeEvent;
        nativeEvent.__datepickerID = datepickerId;
    };
    var focusSpinButton = function (evt) {
        var _a;
        if (evt.target !== yearRef.current &&
            evt.target !== buttonRef.current &&
            evt.target !== dayRef.current &&
            evt.target !== monthRef.current) {
            (_a = dayRef.current) === null || _a === void 0 ? void 0 : _a.focus();
        }
    };
    var datePickedHandler = function (date) {
        var _a;
        var simpleDate = (0, simpledate_1.getSimpleDateFromString)(date);
        if (simpleDate) {
            setDay([simpleDate.date]);
            setMonth([simpleDate.month + 1]);
            setYear([simpleDate.year]);
            setDisplayDatePicker(false);
            setCalendarActiveDate(date);
            (_a = buttonRef.current) === null || _a === void 0 ? void 0 : _a.focus();
        }
    };
    var ariaInvalid = function () {
        var ariaInvalidTotal = ariaInvalidProp === 'true' || ariaInvalidState;
        var isAriaInvalid = ariaInvalidTotal === 'true' || ariaInvalidTotal === true
            ? 'true'
            : undefined;
        return isAriaInvalid;
    };
    var ariaDescribedby = function () {
        var ariaDescribedbyTotal = ariaDescribedbyProp !== null && ariaDescribedbyProp !== void 0 ? ariaDescribedbyProp : ariaDescribedbyState;
        return ariaDescribedbyTotal;
    };
    var handlePaste = function (evt) {
        evt.preventDefault();
        var paste = (evt.clipboardData || window.Clipboard).getData('text');
        var date = (0, simpledate_1.getSimpleDateFromString)(paste);
        if (date) {
            setDay([date.date]);
            setMonth([date.month + 1]);
            setYear([date.year]);
        }
    };
    var _g = (0, react_1.useState)(true), init = _g[0], setInit = _g[1];
    (0, react_1.useEffect)(function () {
        if (init) {
            setInit(false);
            return;
        }
        var _a = lastValidDate.split('.').map(Number), day = _a[0], month = _a[1], year = _a[2];
        if (day * month * year > 0) {
            _onChange(lastValidDate);
            return;
        }
        _onChange('');
    }, [lastValidDate]);
    return (
    // eslint-disable-next-line jsx-a11y/no-static-element-interactions,jsx-a11y/no-noninteractive-element-interactions
    react_1.default.createElement("div", { className: (0, classnames_1.default)('ffe-datepicker', 'ffe-default-mode', {
            'ffe-datepicker--full-width': fullWidth,
            'ffe-input-group--message': hasMessage,
            'ffe-datepicker--invalid': ariaInvalid(),
        }), "data-testid": "date-picker", onClick: function (e) {
            addFlagOnClickEventClickHandler(e);
            focusSpinButton(e);
        }, role: 'group', id: id },
        react_1.default.createElement("div", { className: (0, classnames_1.default)('ffe-input-field', 'ffe-dateinput', {
                'ffe-input-field--invalid': ariaInvalid(),
            }), onBlur: function (evt) {
                var elementReceivingFocus = evt.relatedTarget;
                if (elementReceivingFocus !== yearRef.current &&
                    elementReceivingFocus !== dayRef.current &&
                    elementReceivingFocus !== monthRef.current) {
                    onBlur === null || onBlur === void 0 ? void 0 : onBlur(evt);
                    validateDateIntervals();
                }
            } },
            react_1.default.createElement(SpinButton_1.SpinButton, { ref: dayRef, value: day !== null && day !== void 0 ? day : undefined, min: 1, max: 31, onPaste: handlePaste, onSpinButtonChange: function (newValue, allowFocusNext) {
                    if (allowFocusNext === void 0) { allowFocusNext = true; }
                    return allowFocusNext
                        ? setDay(newValue, function () {
                            var _a;
                            return (_a = monthRef.current) === null || _a === void 0 ? void 0 : _a.focus({
                                preventScroll: true,
                            });
                        })
                        : setDay(newValue);
                }, nextSpinButton: monthRef, maxLength: 2, "aria-invalid": ariaInvalid(), "aria-valuenow": typeof day === 'number' ? day : undefined, "aria-valuetext": "".concat(day), "aria-label": i18n_1.default[locale].DAY, "aria-describedby": ariaDescribedby(), "aria-labelledby": labelId }, day ? (0, padZero_1.padZero)(day) : 'dd'),
            ".",
            react_1.default.createElement(SpinButton_1.SpinButton, { ref: monthRef, value: month !== null && month !== void 0 ? month : undefined, min: 1, max: 12, onPaste: handlePaste, onSpinButtonChange: function (newValue, allowFocusNext) {
                    if (allowFocusNext === void 0) { allowFocusNext = true; }
                    return allowFocusNext
                        ? setMonth(newValue, function () {
                            var _a;
                            return (_a = yearRef.current) === null || _a === void 0 ? void 0 : _a.focus({
                                preventScroll: true,
                            });
                        })
                        : setMonth(newValue);
                }, nextSpinButton: yearRef, prevSpinButton: dayRef, maxLength: 2, "aria-invalid": ariaInvalid(), "aria-valuenow": typeof month === 'number' ? month : undefined, "aria-valuetext": (0, types_1.isMonth)(month)
                    ? "".concat(month, " - ").concat(i18n_1.default[locale]["MONTH_".concat(month)])
                    : undefined, "aria-label": i18n_1.default[locale].MONTH, "aria-describedby": ariaDescribedby(), "aria-labelledby": labelId }, month ? (0, padZero_1.padZero)(month) : 'mm'),
            ".",
            react_1.default.createElement(SpinButton_1.SpinButton, { ref: yearRef, className: 'ffe-dateinput__field-year', value: year !== null && year !== void 0 ? year : undefined, min: 1, max: 9999, onPaste: handlePaste, onSpinButtonChange: function (newValue) {
                    setYear(newValue);
                }, prevSpinButton: monthRef, maxLength: 4, "aria-invalid": ariaInvalid(), "aria-valuetext": "".concat(year), "aria-valuenow": typeof year === 'number' ? year : undefined, "aria-label": i18n_1.default[locale].YEAR, "aria-describedby": ariaDescribedby(), "aria-labelledby": labelId }, year ? year : 'yyyy')),
        react_1.default.createElement(button_1.Button, { onClick: calendarButtonClickHandler, locale: locale, value: calendarActiveDate || '', ref: buttonRef }),
        displayDatePicker && (react_1.default.createElement(calendar_1.Calendar, { calendarClassName: (0, classnames_1.default)('ffe-calendar ffe-calendar--datepicker', { 'ffe-calendar--datepicker--above': calendarAbove }), locale: locale, onDatePicked: datePickedHandler, selectedDate: calendarActiveDate, focusOnMount: true, dropdownCaption: dropdownCaption, minDate: minDate, maxDate: maxDate })),
        !!fieldMessage && (react_1.default.createElement(ffe_form_react_1.ErrorFieldMessage, { as: "p", id: fieldMessageId }, fieldMessage))));
};
exports.DatepickerComp = DatepickerComp;
