"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.DatepickerProvider = exports.DatepickerContext = void 0;
var react_1 = __importStar(require("react"));
var simpledate_1 = require("../datelogic/simpledate");
var dateUtil_1 = require("../util/dateUtil");
var toNumber_1 = require("./toNumber");
exports.DatepickerContext = (0, react_1.createContext)({
    day: null,
    month: null,
    year: null,
    setDay: function () { return null; },
    setMonth: function () { return null; },
    setYear: function () { return null; },
    locale: 'nb',
    calendarActiveDate: '',
    setCalendarActiveDate: function () { return null; },
    setLastChangedValue: function () { return null; },
});
var MONTHS_PER_YEAR = 12;
var MAX_DAYS = 31;
var DatepickerProvider = function (_a) {
    var _b;
    var children = _a.children, _c = _a.value, value = _c === void 0 ? '' : _c, locale = _a.locale;
    var newDate = (0, dateUtil_1.validateDate)(value) ? (0, simpledate_1.getSimpleDateFromString)(value) : '';
    var _d = (0, react_1.useState)(newDate ? newDate.date : null), day = _d[0], setDay = _d[1];
    var _e = (0, react_1.useState)(newDate ? newDate.month + 1 : null), month = _e[0], setMonth = _e[1];
    var _f = (0, react_1.useState)(newDate ? newDate.year : null), year = _f[0], setYear = _f[1];
    var _g = (0, react_1.useState)((_b = newDate === null || newDate === void 0 ? void 0 : newDate.toString()) !== null && _b !== void 0 ? _b : ''), calendarActiveDate = _g[0], setCalendarActiveDate = _g[1];
    var _h = (0, react_1.useState)(value !== null && value !== void 0 ? value : ''), lastChangedValue = _h[0], setLastChangedValue = _h[1];
    (0, react_1.useEffect)(function () {
        var _a;
        if (value !== lastChangedValue) {
            setDay(newDate ? newDate.date : null);
            setMonth(newDate ? newDate.month + 1 : null);
            setYear(newDate ? newDate.year : null);
            setCalendarActiveDate((_a = newDate === null || newDate === void 0 ? void 0 : newDate.toString()) !== null && _a !== void 0 ? _a : '');
        }
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [value]);
    return (react_1.default.createElement(exports.DatepickerContext.Provider, { value: {
            day: day,
            month: month,
            year: year,
            setDay: function (newValue, focusNext) {
                if (focusNext === void 0) { focusNext = undefined; }
                var numbers = newValue.slice(-2);
                var first = numbers[0], second = numbers[1];
                var total = (0, toNumber_1.toNumber)(numbers);
                if (total > MAX_DAYS) {
                    focusNext === null || focusNext === void 0 ? void 0 : focusNext();
                }
                else if (first > 3) {
                    setDay(total);
                    focusNext === null || focusNext === void 0 ? void 0 : focusNext();
                }
                else {
                    setDay(total);
                    if (second !== undefined) {
                        focusNext === null || focusNext === void 0 ? void 0 : focusNext();
                    }
                }
            },
            setMonth: function (newValue, focusNext) {
                if (focusNext === void 0) { focusNext = undefined; }
                var numbers = newValue.slice(-2);
                var first = numbers[0], second = numbers[1];
                var total = (0, toNumber_1.toNumber)(numbers);
                if (total > MONTHS_PER_YEAR) {
                    focusNext === null || focusNext === void 0 ? void 0 : focusNext();
                }
                else if (first > 1) {
                    setMonth(total);
                    focusNext === null || focusNext === void 0 ? void 0 : focusNext();
                }
                else {
                    setMonth(total);
                    if (second !== undefined) {
                        focusNext === null || focusNext === void 0 ? void 0 : focusNext();
                    }
                }
            },
            setYear: function (newValue) {
                setYear((0, toNumber_1.toNumber)(newValue.slice(-4)));
            },
            calendarActiveDate: calendarActiveDate,
            setCalendarActiveDate: function (date) {
                setCalendarActiveDate(date);
            },
            locale: locale,
            setLastChangedValue: function (val) {
                setLastChangedValue(val);
            },
        } }, children));
};
exports.DatepickerProvider = DatepickerProvider;
