"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SpinButton = void 0;
var react_1 = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
exports.SpinButton = react_1.default.forwardRef(function (_a, ref) {
    var className = _a.className, onSpinButtonChange = _a.onSpinButtonChange, maxLength = _a.maxLength, min = _a.min, max = _a.max, value = _a.value, nextSpinButton = _a.nextSpinButton, prevSpinButton = _a.prevSpinButton, children = _a.children, rest = __rest(_a, ["className", "onSpinButtonChange", "maxLength", "min", "max", "value", "nextSpinButton", "prevSpinButton", "children"]);
    var history = (0, react_1.useRef)([]);
    var handleKeyDown = function (evt) {
        var _a, _b, _c;
        evt.stopPropagation();
        if (/\d/.test(evt.key)) {
            history.current =
                history.current.length === maxLength
                    ? (history.current = [parseInt(evt.key)])
                    : history.current.concat(parseInt(evt.key));
            onSpinButtonChange(history.current);
        }
        else if (evt.key === 'Backspace' || evt.key === 'Delete') {
            history.current = [];
            if (value === 0) {
                (_a = prevSpinButton === null || prevSpinButton === void 0 ? void 0 : prevSpinButton.current) === null || _a === void 0 ? void 0 : _a.focus();
                return;
            }
            var newValue = value === null || value === void 0 ? void 0 : value.toString().slice(0, -1);
            history.current = newValue
                ? newValue.split('').map(Number)
                : [];
            onSpinButtonChange(history.current);
        }
        else if (evt.key === 'ArrowUp') {
            evt.preventDefault();
            var newValue = (value !== null && value !== void 0 ? value : 0) + 1;
            if (newValue && newValue !== null && newValue > max) {
                newValue = min;
            }
            onSpinButtonChange([newValue], false);
        }
        else if (evt.key === 'ArrowDown') {
            evt.preventDefault();
            var newValue = (value !== null && value !== void 0 ? value : 0) - 1;
            if (newValue < min) {
                newValue = max;
            }
            onSpinButtonChange([newValue], false);
        }
        else if (evt.key === 'ArrowLeft') {
            evt.preventDefault();
            (_b = prevSpinButton === null || prevSpinButton === void 0 ? void 0 : prevSpinButton.current) === null || _b === void 0 ? void 0 : _b.focus();
        }
        else if (evt.key === 'ArrowRight') {
            evt.preventDefault();
            (_c = nextSpinButton === null || nextSpinButton === void 0 ? void 0 : nextSpinButton.current) === null || _c === void 0 ? void 0 : _c.focus();
        }
    };
    return (react_1.default.createElement("span", __assign({ role: 'spinbutton', inputMode: 'numeric', className: (0, classnames_1.default)(className, 'ffe-dateinput__field'), tabIndex: 0, onFocus: function () {
            history.current = [];
        }, "aria-valuemin": min, "aria-valuemax": max, "aria-valuenow": value, ref: ref, onKeyDown: handleKeyDown }, rest), children));
});
