"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validateDate = validateDate;
exports.isDateInputWithTwoDigitYear = isDateInputWithTwoDigitYear;
exports.getPaddedDateString = getPaddedDateString;
var padZero_1 = require("../datepicker/padZero");
var dateRegex = /^(\d{1,2})(\.| |-|\/)?(\d{0,2})\2?(\d{0,2}(\d{2})?)$/;
function validateDate(date) {
    return dateRegex.exec(date);
}
function isDateInputWithTwoDigitYear(value) {
    var _a;
    return ((_a = validateDate(value)) === null || _a === void 0 ? void 0 : _a[4].length) === 2;
}
function getPaddedDateString(day, month, year) {
    return "".concat((0, padZero_1.padZero)(day !== null && day !== void 0 ? day : 0), ".").concat((0, padZero_1.padZero)(month !== null && month !== void 0 ? month : 0), ".").concat(year);
}
