import React from 'react';
import { Locale } from '../datelogic/types';
interface HeaderProps {
    datepickerId: string;
    month: string;
    nextMonthHandler: React.MouseEventHandler<HTMLButtonElement>;
    nextMonthLabel: string;
    previousMonthHandler: React.MouseEventHandler<HTMLButtonElement>;
    previousMonthLabel: string;
    year: number;
    prevMonthButtonElement: React.RefObject<HTMLButtonElement>;
    nextMonthButtonElement: React.RefObject<HTMLButtonElement>;
    /** Nåværende månedsnummer (1-12) */
    monthNumber: number;
    /** Om måned- og år-dropdown skal vises i kalenderen */
    dropdownCaption?: boolean;
    /** Nåværende språkkode */
    locale: Locale;
    /** Navigasjons-handler når måned/år endres direkte */
    onMonthYearChange?: (month: number, year: number) => void;
    /** Tidligste tillatte dato (format: 'dd.mm.yyyy') - brukes kun til å bestemme år-intervall i dropdown */
    minDate?: string | null;
    /** Seneste tillatte dato (format: 'dd.mm.yyyy') - brukes kun til å bestemme år-intervall i dropdown */
    maxDate?: string | null;
}
export declare const Header: React.FC<HeaderProps>;
export {};
