import { SimpleDate } from './simpledate';
import { CalendarButtonState } from './types';
declare const supportedLocales: readonly ["nb", "nn", "en"];
type Locale = (typeof supportedLocales)[number];
export declare class SimpleCalendar {
    locale: Locale;
    focusedDate: SimpleDate;
    selectedDate?: SimpleDate | null;
    firstDay: number;
    constructor(initialDate?: SimpleDate | null, locale?: Locale);
    get focusedMonth(): any;
    get focusedYear(): number;
    get dayNames(): {
        name: any;
        shortName: any;
    }[];
    get previousName(): "Previous month" | "Forrige månad" | "Forrige måned";
    get nextName(): "Next month" | "Neste månad" | "Neste måned";
    previousYear(): void;
    nextYear(): void;
    nextMonth(): void;
    previousMonth(): void;
    nextWeek(): void;
    previousWeek(): void;
    nextDay(): void;
    previousDay(): void;
    firstDateOfMonth(): void;
    lastDateOfMonth(): void;
    selectFocusedDate(): void;
    isDateWithinDateRange(date: SimpleDate): boolean;
    selectTimestamp(timestamp: number): void;
    selected(): string;
    focused(): string;
    selectDateString(date: string): void;
    get visibleDates(): Week[];
}
type Week = {
    dates: CalendarButtonState[];
    number: number;
};
export {};
