export declare class SimpleDate {
    internalDate: Date;
    constructor(date?: Date);
    get day(): number;
    get date(): number;
    get month(): number;
    get year(): number;
    get daysInMonth(): number;
    get timestamp(): number;
    set date(date: number);
    set year(year: number);
    set month(month: number);
    adjust({ period, offset, }: {
        period: 'D' | 'M' | 'Y';
        offset: number;
    }): void;
    equal(other: SimpleDate): boolean;
    isBefore(other: SimpleDate): boolean;
    isAfter(other: SimpleDate): boolean;
    clone(): SimpleDate;
    format(): string;
    toString(): string;
}
export declare const getSimpleDateToday: () => SimpleDate;
export declare const getSimpleDateFromTimestamp: (timestamp: number) => SimpleDate;
export declare const getSimpleDateFromString: (value: string | undefined | null, onSuccess?: (simpleDate: SimpleDate) => void) => SimpleDate | null;
