export type DatepickerTestHelper = {
    /**
     * The datepicker element
     */
    element: HTMLElement;
    /**
     * Function to get the value of the datepicker
     *
     * @returns string in the format 'dd.mm.yyyy' or empty string if the datepicker is empty
     */
    getValue: () => string;
    /**
     * Function to set the value of the datepicker
     *
     * @param value string in the format 'dd.mm.yyyy'
     * @returns void
     */
    setValue: (value: string) => Promise<void>;
};
/**
 * Get a datepicker with helper functions by label
 *
 * @param label label of the datepicker element you want to get
 * @param index if there are multiple datepicker elements with the same label, you can specify which one you want to get
 * @returns DatepickerTestHelper
 */
export declare function getDatepickerByLabelText(label: string, index?: number): Promise<DatepickerTestHelper>;
